/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE NEW COLONY:
// CREATED BY DANY:
// APRIL 2007:
// A RANDOM MAP FOR AGE OF EMPIRES III: THE NUMBER 49:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
		int subCiv1=-1;
		int subCiv2=-1;
		
		if (rmAllocateSubCivs(3) == true)
   
   {
		
		subCiv0=rmGetCivID("Iroquois");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Iroquois");
		
		subCiv1=rmGetCivID("Iroquois");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Iroquois");
		
		subCiv2=rmGetCivID("Iroquois");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Iroquois");
   }		

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int playerTiles=12500;
        
		
        int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
        rmEchoInfo("Map size="+size+"m x "+size+"m");
        rmSetMapSize(448, 448);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
        // PICKS DEFAULT TERRAIN AND WATER:
        
		// SET SEA TYPE:
		rmSetSeaType("new england coast");

	    // SOME MAP TURBULENCE:
		// SET THE MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE THE TEXAS FOR THE MOMENT:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(0.2);

        // PICKS A DEFAULT WATER HEIGHT:
        rmSetSeaLevel(4.0);
        
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
        
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET MAP TYPE:
		rmSetMapType("newEngland");
	    rmSetMapType("water");
		rmSetMapType("grass");
	    
	    // SET LIGHTING:
	    rmSetLightingSet("new england");
	    
		// MAKE THE CORNERS:
		rmSetWorldCircleConstraint(true);
	    
		// SET THE WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
		
		// CHOOSE THE MERCS:
	    chooseMercs();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ********************************************** DEFINE SOME CLASSES: ****************************************** //
// ************************************ THESE ARE USED LATER FOR CONSTRAINTS: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
		int classbigContinent=rmDefineClass("big continent");
		rmDefineClass("startingUnit");
		rmDefineClass("socketClass");
		rmDefineClass("classForest");
		int canyon=rmDefineClass("canyon");
		rmDefineClass("nuggets");
		rmDefineClass("natives");
		rmDefineClass("classWall");

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************* THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTS:
        int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
        int longPlayerConstraint=rmCreateClassDistanceConstraint("continent stays away from players", classPlayer, 12.0);

		// FOREST AVOIDANCE:
		int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 10.0);
        		
		// BONUS AREA CONSTRAINT:
        int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 35.0);
		
		// CANYONS AVOIDANCE:		
		int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 8.0);
		int avoidCloseCanyons=rmCreateClassDistanceConstraint("close avoid canyons", rmClassID("canyon"), 2.0);
	   		
		// WALL AVOIDANCE:
		int wallConstraint=rmCreateClassDistanceConstraint("wall vs. wall", rmClassID("classWall"), 40.0);
	   		
		// SILVER MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 20.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 5.0);
        		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
		// NEW EXTRA STUFF FOR WATER SPAWN POINT AVOIDANCE:
	    int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 20.0);
	    int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 15);
	    int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 35.0);
        int avoidPlayerNugget=rmCreateTypeDistanceConstraint("player nugget avoid nugget", "AbstractNugget", 20.0);
        int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);

        // DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("stuff avoids sheep", "sheep", 10.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 2.0);
		
		// TURKEY AVOIDANCE:
		int avoidTurkey=rmCreateTypeDistanceConstraint("stuff avoids turkey", "turkey", 10.0);
		int avoidCloseTurkey=rmCreateTypeDistanceConstraint("close avoids turkey", "turkey", 2.0);
		
		// TREE AVOIDANCE:
		int avoidTree=rmCreateTypeDistanceConstraint("stuff avoids tree", "TreeNewEngland", 10.0);
		int avoidCloseTree=rmCreateTypeDistanceConstraint("close avoids tree", "TreeNewEngland", 2.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
				
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
		
		// CONSTRAINT TO AVOID WATER:
        int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water 15", "Land", false, 15.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water medium", "Land", false, 20.0);
        int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 30.0);
        int avoidWater5 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 5.0);
        
	    // SOCKET AVOIDANCE:
		int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("socketClass"), 8.0);
		int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("socketClass"), 2.0);
		
		// CIRCLE CONSTRAINT:
		int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.47), rmDegreesToRadians(0), rmDegreesToRadians(360));

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// *************************************** BUILD UP THE BIG CONTINENT: ****************************************** // 
// ****************************** - CALLED, UNORIGINALLY ENOUGH, "BIG CONTINENT" - ****************************** //
/*================================================================================================================*/

        int bigContinentID=rmCreateArea("big continent");
        rmSetAreaSize(bigContinentID, 0.52, 0.52);		// 0.65, 0.65
        rmSetAreaWarnFailure(bigContinentID, false);
        rmAddAreaConstraint(bigContinentID, longPlayerConstraint);
        rmAddAreaToClass(bigContinentID, classbigContinent);
        rmSetAreaSmoothDistance(bigContinentID, 25);
	    rmSetAreaMix(bigContinentID, "newengland_grass");
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 2.0);
        rmSetAreaBaseHeight(bigContinentID, 6.0);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2);      
	    rmSetAreaCoherence(bigContinentID, 0.75);
	    // rmSetAreaLocation(bigContinentID, 0.5, 0.85);
		   rmSetAreaLocation(bigContinentID, 0.25, 0.25);
        rmSetAreaEdgeFilling(bigContinentID, 5);
	    rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
		//rmSetAreaMix(bigContinentID, "rockies_snow");
	    rmBuildArea(bigContinentID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.27);
/*================================================================================================================*/
// ************************* BUILD UP SMALL CONTINENT SPURS CALLED "SMALL CONTINENT 1&2" ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // Build up small continent spurs called "small continent spur 1 & 2"
        int smallContinent1ID=rmCreateArea("small continent spur 1");
        rmSetAreaSize(smallContinent1ID, 0.2, 0.2);
        rmSetAreaWarnFailure(smallContinent1ID, false);
        rmAddAreaConstraint(smallContinent1ID, longPlayerConstraint);
        rmAddAreaToClass(smallContinent1ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent1ID, 25);
	    rmSetAreaMix(smallContinent1ID, "newengland_grass");
        rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent1ID, 2.0);
        rmSetAreaBaseHeight(smallContinent1ID, 6.0);
        rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent1ID, 3);
        rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
	    rmSetAreaCoherence(smallContinent1ID, 0.95);
	    // rmSetAreaLocation(smallContinent1ID, 0.8, 0.6);
		   rmSetAreaLocation(smallContinent1ID, 0.2, 0.7);
        rmSetAreaEdgeFilling(smallContinent1ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
	    rmBuildArea(smallContinent1ID);

	    // Build up small continent spurs called "small continent spur 1 & 2"
        int smallContinent2ID=rmCreateArea("small continent spur 2");
        rmSetAreaSize(smallContinent2ID, 0.2, 0.2);
        rmSetAreaWarnFailure(smallContinent2ID, false);
        rmAddAreaConstraint(smallContinent2ID, longPlayerConstraint);
        rmAddAreaToClass(smallContinent2ID, classbigContinent);
        rmSetAreaSmoothDistance(smallContinent2ID, 25);
	    rmSetAreaMix(smallContinent2ID, "newengland_grass");
        rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent2ID, 2.0);
        rmSetAreaBaseHeight(smallContinent2ID, 6.0);
        rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent2ID, 3);
        rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
	    rmSetAreaCoherence(smallContinent2ID, 0.95);
	    // rmSetAreaLocation(smallContinent2ID, 0.2, 0.6);
		   rmSetAreaLocation(smallContinent2ID, 0.7, 0.2);
        rmSetAreaEdgeFilling(smallContinent2ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
	    rmBuildArea(smallContinent2ID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ***************************************** SET UP THE PLAYER LOCATIONS: *************************************** //
/*================================================================================================================*/

        if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.2,0.8);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.8,0.2);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	} 
	 
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ****************************************** SET UP THE PLAYER AREAS: ****************************************** //
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
		
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
      
	    // ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
	    rmAddAreaToClass(id, classPlayer);
        
		// SET AREA MIN AND MAX:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
	    // rmAddAreaConstraint(id, playerConstraint); 
        // rmAddAreaConstraint(id, playerEdgeConstraint); 
      
	    // SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
      
	    // SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
		
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.39);
/*================================================================================================================*/	    
// *************************************** DEFINE THE PLACEMENT ORDER: ****************************************** //
/*================================================================================================================*/  
   
   // PLACEMENT ORDER:
   // TRADE ROUTE -> LAKES -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:
   // TEXT:
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE TRADE ROUTES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE TRADE ROUTE 1:
		int tradeRouteID = rmCreateTradeRoute();
        int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
        rmSetObjectDefTradeRouteID(socketID, tradeRouteID);

        rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
        rmAddObjectDefToClass(socketID, rmClassID("socketClass"));
        rmSetObjectDefMinDistance(socketID, 0.0);
        rmSetObjectDefMaxDistance(socketID, 12.0);

	    rmAddTradeRouteWaypoint(tradeRouteID, 0.03, 0.45);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.15, 0.35);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.25, 0.35);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.25);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.35, 0.15);
		rmAddTradeRouteWaypoint(tradeRouteID, 0.45, 0.03);
		
        bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
        if(placedTradeRoute == false)
        rmEchoError("Failed to place trade route"); 
  
	    // ADD THE SOCKETS ALONG THE TRADE ROUTE:
        vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.05);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
		
		socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

        socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.95);
        rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE LAKES: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.46);
/*================================================================================================================*/
// ************************** ISLES OF SHOALS - THESE ARE SET IN SPECIFIC LOCATIONS: **************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        int bonusIslandID1=rmCreateArea("isle of shoals 1");
        rmSetAreaSize(bonusIslandID1, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
        rmSetAreaTerrainType(bonusIslandID1, "new_england\ground1_ne");
        rmSetAreaMix(bonusIslandID1, "newengland_grass");
	    // rmSetAreaMix(bonusIslandID1, "newengland_rock");
        rmSetAreaBaseHeight(bonusIslandID1, 6.0);
        rmSetAreaSmoothDistance(bonusIslandID1, 5);
        rmSetAreaWarnFailure(bonusIslandID1, false);
	    rmSetAreaMinBlobs(bonusIslandID1, 1);
        rmSetAreaMaxBlobs(bonusIslandID1, 1);
        rmSetAreaMinBlobDistance(bonusIslandID1, 1);
	    rmSetAreaMaxBlobDistance(bonusIslandID1, 1);
        rmSetAreaCoherence(bonusIslandID1, 0.95);
        rmAddAreaConstraint(bonusIslandID1, bigContinentConstraint);
        rmAddAreaConstraint(bonusIslandID1, longPlayerConstraint);
		rmSetAreaLocation(bonusIslandID1, 0.85, 0.60);
		rmBuildArea(bonusIslandID1);

/*----------------------------------------------------------------------------------------------------------------*/		
	    
		int bonusIslandID2=rmCreateArea("isle of shoals 2");
		rmSetAreaSize(bonusIslandID2, rmAreaTilesToFraction(750), rmAreaTilesToFraction(750));
		rmSetAreaTerrainType(bonusIslandID2, "new_england\ground1_ne");
		rmSetAreaMix(bonusIslandID2, "newengland_grass");
		// rmSetAreaMix(bonusIslandID2, "newengland_rock");
		rmSetAreaBaseHeight(bonusIslandID2, 6.0);
		rmSetAreaSmoothDistance(bonusIslandID2, 5);
		rmSetAreaWarnFailure(bonusIslandID2, false);
		rmSetAreaMinBlobs(bonusIslandID2, 1);
		rmSetAreaMaxBlobs(bonusIslandID2, 1);
		rmSetAreaMinBlobDistance(bonusIslandID2, 1);
		rmSetAreaMaxBlobDistance(bonusIslandID2, 1);
		rmSetAreaCoherence(bonusIslandID2, 0.95);
		rmAddAreaConstraint(bonusIslandID2, bigContinentConstraint);
		rmAddAreaConstraint(bonusIslandID2, longPlayerConstraint);
		rmSetAreaLocation(bonusIslandID2, 0.70, 0.75);
		rmBuildArea(bonusIslandID2);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/   
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv0 == rmGetCivID("iroquois"))
	
	{  
		
		int iroquois1VillageID = -1;
		iroquois1VillageID = rmCreateGrouping("iroquois village 1", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois1VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois1VillageID, 0.0);
		rmAddGroupingToClass(iroquois1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois1VillageID, 0, 0.45, 0.45);
		
	} 
	
	    if (subCiv1 == rmGetCivID("iroquois"))
	
	{  
		
		int iroquois2VillageID = -1;
		iroquois2VillageID = rmCreateGrouping("iroquois village 2", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois2VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois2VillageID, 0.0);
		rmAddGroupingToClass(iroquois2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois2VillageID, 0, 0.64, 0.225);
		
	} 
	
	    if (subCiv2 == rmGetCivID("iroquois"))
	
	{  
		
		int iroquois3VillageID = -1;
		iroquois3VillageID = rmCreateGrouping("iroquois village 3", "native iroquois village 1");
		rmSetGroupingMinDistance(iroquois3VillageID, 0.0);
		rmSetGroupingMaxDistance(iroquois3VillageID, 0.0);
		rmAddGroupingToClass(iroquois3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(iroquois3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(iroquois3VillageID, 0, 0.224, 0.64);
		
	} 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// **************** DEFINE AND PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: *************** //
/*================================================================================================================*/ 
 
        //DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 5.0);
	    rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefToClass(startingUnits, rmClassID("startingUnit"));
	    rmAddObjectDefConstraint(startingUnits, avoidAll);

	    // DEFINE THE STARTING TCID:
	    int startingTCID= rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));

	    // VARIABLES FOR THE STARTING PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;

	    // DEFINE THE STARTING TREE:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 10.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 15.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);

	    // DEFINE THE STARTING BERRYBUSH:
		int StartBerryBushID=rmCreateObjectDef("starting BerryBush");
	    rmAddObjectDefItem(StartBerryBushID, "BerryBush", 3, 5.0);
	    rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
	    rmSetObjectDefMaxDistance(StartBerryBushID, 15.0);
	    rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
        rmSetObjectDefMinDistance(playerNuggetID, 30.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
	    rmAddObjectDefConstraint(playerNuggetID, avoidPlayerNugget);
	    rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);

	    // DEFINE THE WATER FLAG:
		int waterFlagID=-1;

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //
/*================================================================================================================*/
	
	    for(i=1; <cNumberPlayers)
		
	{
	
		// CLEAR THE CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
		// PLACE THE STARTING TCID AND STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// EVERYONE GETS ONE ORE GROUPING CLOSE BY:
		// DEFINE THE PLAYER GOLD:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddGroupingToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE PLAYER GOLD:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BERRYBUSH:
		rmPlaceObjectDefAtLoc(StartBerryBushID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		
		// PLACE THE STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE WATER FLAG:
		waterFlagID=rmCreateObjectDef("HC water flag "+i);
		rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
		rmAddClosestPointConstraint(flagEdgeConstraint);
		rmAddClosestPointConstraint(flagVsFlag);
		rmAddClosestPointConstraint(flagLand);
		vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
        vector closestPoint = rmFindClosestPointVector(TCLocation, rmXFractionToMeters(1.0));

		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		// CLEAR THE CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints();
		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ********************************* DEFINE AND PLACE THE NUGGETS ON THE MAP: *********************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidCloseNugget);
		//rmAddObjectDefConstraint(nugget1ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.60, 0.50);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.30, 0.40);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidCloseNugget);
		//rmAddObjectDefConstraint(nugget2ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.05, 0.65);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.65, 0.05);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidCloseNugget);
		rmAddObjectDefConstraint(nugget3ID, avoidWater5);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.10, 0.30);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.10);
        rmPlaceObjectDefInArea(nugget3ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(nugget3ID, 0, bonusIslandID2, 1); 		
		rmPlaceObjectDefInArea(nugget3ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(nugget3ID, 0, bonusIslandID2, 1); 

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE AND PLACE NUGGETS NUMBER 4:
		int nugget4ID= rmCreateObjectDef("nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, 0.0);
	    rmAddObjectDefConstraint(nugget4ID, avoidCloseNugget);
		//rmAddObjectDefConstraint(nugget4ID, avoidWater2);
  	    rmSetNuggetDifficulty(1, 3);
	    
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.45, 0.50);
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.45, 0.40);		
			
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE DEER: ****************************************** //
/*================================================================================================================*/ 

	   
        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.40, 0.30);
		

/*----------------------------------------------------------------------------------------------------------------*/

		
		int deer2ID=rmCreateObjectDef("The Deer Herds 2");
        rmAddObjectDefItem(deer2ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer2ID, 0.0);
        rmSetObjectDefMaxDistance(deer2ID, 0.0);
	    rmAddObjectDefConstraint(deer2ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer2ID, true);
	    
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.05, 0.35);
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.35, 0.05);
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE SHEEP: ***************************************** //
/*================================================================================================================*/ 

	   
        int sheep1ID=rmCreateObjectDef("The Sheep Herds 1");
        rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(5,9), 4.0);
        rmSetObjectDefMinDistance(sheep1ID, 0.0);
        rmSetObjectDefMaxDistance(sheep1ID, 0.0);
	    rmAddObjectDefConstraint(sheep1ID, avoidDeer);
		rmSetObjectDefCreateHerd(sheep1ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.325, 0.525);
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.525, 0.325);

/*----------------------------------------------------------------------------------------------------------------*/

        int sheep2ID=rmCreateObjectDef("The Sheep Herds 2");
        rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(5,9), 4.0);
        rmSetObjectDefMinDistance(sheep2ID, 0.0);
        rmSetObjectDefMaxDistance(sheep2ID, 0.0);
	    rmAddObjectDefConstraint(sheep2ID, avoidDeer);
		rmSetObjectDefCreateHerd(sheep2ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.1, 0.7);
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.7, 0.1);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int sheep3ID=rmCreateObjectDef("The Sheep Herds 3");
        rmAddObjectDefItem(sheep3ID, "sheep", rmRandInt(5,7), 3.0);
        rmSetObjectDefMinDistance(sheep3ID, 0.0);
        rmSetObjectDefMaxDistance(sheep3ID, 0.0);
	    rmAddObjectDefConstraint(sheep3ID, avoidDeer);
		rmSetObjectDefCreateHerd(sheep3ID, true);
	    
		rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.2, 0.3);
		rmPlaceObjectDefAtLoc(sheep3ID, 0, 0.3, 0.2);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.76);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE TURKEY: ***************************************** //
/*================================================================================================================*/ 
	   
        int turkey1ID=rmCreateObjectDef("The Turkey Group 1");
        rmAddObjectDefItem(turkey1ID, "turkey", rmRandInt(5,9), 4.0);
        rmSetObjectDefMinDistance(turkey1ID, 0.0);
        rmSetObjectDefMaxDistance(turkey1ID, 0.0);
	    rmAddObjectDefConstraint(turkey1ID, avoidDeer);
		rmSetObjectDefCreateHerd(turkey1ID, true);
	    
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.2, 0.375);
		rmPlaceObjectDefAtLoc(turkey1ID, 0, 0.375, 0.2);		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE GOLD MINES: **************************************** //
/*================================================================================================================*/
		
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
		//rmAddObjectDefConstraint(gold1ID, avoidWater2);
		
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.55, 0.55);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.35, 0.35);
        rmPlaceObjectDefAtLoc(gold1ID, 0, 0.365, 0.525);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.525, 0.365);

/*----------------------------------------------------------------------------------------------------------------*/

        int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
		//rmAddObjectDefConstraint(gold2ID, avoidWater2);
		
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.05, 0.55);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.55, 0.05);
		
/*----------------------------------------------------------------------------------------------------------------*/

        int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidCloseGold);
		rmAddObjectDefConstraint(gold3ID, avoidWater5);
		
		rmPlaceObjectDefInArea(gold3ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(gold3ID, 0, bonusIslandID2, 1); 
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.81);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidCloseFruits);
		rmAddObjectDefConstraint(berries1ID, avoidWater5);
		rmAddObjectDefConstraint(berries1ID, avoidCloseGold);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.10, 0.60);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.10);
        rmPlaceObjectDefInArea(berries1ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(berries1ID, 0, bonusIslandID2, 1); 
		
/*----------------------------------------------------------------------------------------------------------------*/

        int berries2ID = rmCreateObjectDef("The Berries 2");
		rmAddObjectDefItem(berries2ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries2ID, 0.0);
		rmSetObjectDefMaxDistance(berries2ID, 0.0);
		rmAddObjectDefConstraint(berries2ID, avoidCloseFruits);
		rmAddObjectDefConstraint(berries2ID, avoidWater5);
		rmAddObjectDefConstraint(berries2ID, avoidCloseGold);
		
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.115, 0.415);
		rmPlaceObjectDefAtLoc(berries2ID, 0, 0.415, 0.115);	

/*----------------------------------------------------------------------------------------------------------------*/

        int berries3ID = rmCreateObjectDef("The Berries 3");
		rmAddObjectDefItem(berries3ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries3ID, 0.0);
		rmSetObjectDefMaxDistance(berries3ID, 0.0);
		rmAddObjectDefConstraint(berries3ID, avoidCloseFruits);
		rmAddObjectDefConstraint(berries3ID, avoidWater5);
		rmAddObjectDefConstraint(berries3ID, avoidCloseGold);
		
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.40, 0.45);
		rmPlaceObjectDefAtLoc(berries3ID, 0, 0.50, 0.45);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.82);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE TREES: **************************************** //
/*================================================================================================================*/
		int trees1ID = rmCreateObjectDef("The Trees 1");
		rmAddObjectDefItem(trees1ID, "TreeNewEngland", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(trees1ID, 0.0);
		rmSetObjectDefMaxDistance(trees1ID, 0.0);
		rmAddObjectDefConstraint(trees1ID, avoidCloseTree);
		rmAddObjectDefConstraint(trees1ID, avoidWater5);
		rmAddObjectDefConstraint(trees1ID, avoidCloseFruits);
		rmAddObjectDefConstraint(trees1ID, avoidCloseGold);
		
		rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID2, 1); 
		rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID2, 1); 
		rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID1, 1);
        rmPlaceObjectDefInArea(trees1ID, 0, bonusIslandID2, 1); 
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************* SILLY ROCK WALLS CAN GET PLACED LAST: MAY NOT PLACE AT ALL: ************************ //
/*================================================================================================================*/
	
	    int stoneWallType = -1;
	    int stoneWallID = -1;
		int stoneWall2ID = -1;
	    int stoneWall3ID = -1;
		int stoneWall4ID = -1;
		int stoneWallCount = cNumberNonGaiaPlayers*0.5;	
	    rmEchoInfo("stoneWall count = "+stoneWallCount);
		
/*----------------------------------------------------------------------------------------------------------------*/
	    
		for(i=0; < stoneWallCount)
		
	{
	
		stoneWallType = rmRandInt(1,4);
        stoneWallID = rmCreateGrouping("stone wall "+i, "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWallID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWallID, 0.0);
        rmSetGroupingMaxDistance(stoneWallID, 0.0);
		rmAddGroupingConstraint(stoneWallID, wallConstraint);
		rmAddGroupingConstraint(stoneWallID, avoidAll);
		rmAddGroupingConstraint(stoneWallID, avoidStartingUnitsSmall);
		rmPlaceGroupingAtLoc(stoneWallID, 0, 0.325, 0.825);
	
   }
   
/*----------------------------------------------------------------------------------------------------------------*/		
	    
		for(i=0; < stoneWallCount)
	{
		stoneWallType = rmRandInt(1,4);
        stoneWall2ID = rmCreateGrouping("stone wall 2", "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWall2ID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWall2ID, 0.0);
        rmSetGroupingMaxDistance(stoneWall2ID, 0.0);
		rmAddGroupingConstraint(stoneWall2ID, wallConstraint);
		rmAddGroupingConstraint(stoneWall2ID, avoidAll);
		rmAddGroupingConstraint(stoneWall2ID, avoidStartingUnitsSmall);
		rmPlaceGroupingAtLoc(stoneWall2ID, 0, 0.825, 0.325);
	}	
   
/*----------------------------------------------------------------------------------------------------------------*/   
        
		for(i=0; < stoneWallCount)
	{
		stoneWallType = rmRandInt(1,4);
        stoneWall3ID = rmCreateGrouping("stone wall 3", "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWall3ID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWall3ID, 0.0);
        rmSetGroupingMaxDistance(stoneWall3ID, 0.0);
		rmAddGroupingConstraint(stoneWall3ID, wallConstraint);
		rmAddGroupingConstraint(stoneWall3ID, avoidCloseSocket);
		rmAddGroupingConstraint(stoneWall3ID, avoidCloseTradeRoute);
		rmAddGroupingConstraint(stoneWall3ID, avoidCloseGold);
		
		rmPlaceGroupingAtLoc(stoneWall3ID, 0, 0.5, 0.075);
	}	
	
/*----------------------------------------------------------------------------------------------------------------*/	
	   
	   for(i=0; < stoneWallCount)
	{
		stoneWallType = rmRandInt(1,4);
        stoneWall4ID = rmCreateGrouping("stone wall 4", "ne_rockwall "+stoneWallType);
		rmAddGroupingToClass(stoneWall4ID, rmClassID("classWall"));
        rmSetGroupingMinDistance(stoneWall4ID, 0.0);
        rmSetGroupingMaxDistance(stoneWall4ID, 0.0);
		rmAddGroupingConstraint(stoneWall4ID, wallConstraint);
		rmAddGroupingConstraint(stoneWall4ID, avoidCloseSocket);
		rmAddGroupingConstraint(stoneWall4ID, avoidCloseTradeRoute);
		rmAddGroupingConstraint(stoneWall4ID, avoidCloseGold);
		
		rmPlaceGroupingAtLoc(stoneWall4ID, 0, 0.075, 0.5);
	}
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.86);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SMALL MESAS: *************************************** //
/*================================================================================================================*/
        
		// DEFINE AND PLACE SMALL MESA NUMBER 1: 
		int smallCliff1Height=rmRandInt(0,10);
		int smallMesa1ID=rmCreateArea("small mesa 1");
		rmSetAreaSize(smallMesa1ID, 0.025, 0.025);
		rmSetAreaWarnFailure(smallMesa1ID, false);
		rmSetAreaCliffType(smallMesa1ID, "New England");
		rmAddAreaToClass(smallMesa1ID, rmClassID("canyon"));	
		// rmSetAreaCliffEdge(smallMesa1ID, 1, 1.0, 0.1, 1.0, 0);
		   rmSetAreaCliffEdge(smallMesa1ID, 2, 0.4, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesa1ID, rmRandInt(6,8), 1.0, 1.0);
		rmSetAreaMinBlobs(smallMesa1ID, 1);
		rmSetAreaMaxBlobs(smallMesa1ID, 1);
		rmSetAreaMinBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaMaxBlobDistance(smallMesa1ID, 1.0);
		rmSetAreaCoherence(smallMesa1ID, 1.0);
		//rmAddAreaConstraint(smallMesa1ID, avoidCloseNatives);
		rmSetAreaLocation(smallMesa1ID, 0.45, 0.45); 
	    rmBuildArea(smallMesa1ID);		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ***************************************** DEFINE AND PLACE THE FORESTS: ************************************** //
/*================================================================================================================*/
 
        int forest1ID = -1;
        forest1ID=rmCreateArea("forest 1");
        rmSetAreaWarnFailure(forest1ID, false);
        rmSetAreaSize(forest1ID, 0.025, 0.025);
        rmSetAreaForestType(forest1ID, "new england forest");
        rmSetAreaForestDensity(forest1ID, 1.0);
        rmSetAreaForestClumpiness(forest1ID, 0.0);
        rmSetAreaForestUnderbrush(forest1ID, 0.0);
        rmSetAreaMinBlobs(forest1ID, 1);
        rmSetAreaMaxBlobs(forest1ID, 1);
        rmSetAreaMinBlobDistance(forest1ID, 1.0);
        rmSetAreaMaxBlobDistance(forest1ID, 1.0);
        rmSetAreaCoherence(forest1ID, 1.0);
        rmSetAreaSmoothDistance(forest1ID, 10);
        rmAddAreaToClass(forest1ID, rmClassID("classForest")); 
        rmAddAreaConstraint(forest1ID, forestConstraint);
		//rmAddAreaConstraint(forest1ID, avoidCloseNatives);
		//rmAddAreaConstraint(forest1ID, avoidCloseDeer);
		//rmAddAreaConstraint(forest1ID, avoidCloseMoose);
		rmSetAreaLocation(forest1ID, 0.35, 0.65); 
        rmBuildArea(forest1ID);
		
		int forest2ID = -1;
        forest2ID=rmCreateArea("forest 2");
        rmSetAreaWarnFailure(forest2ID, false);
        rmSetAreaSize(forest2ID, 0.025, 0.025);
        rmSetAreaForestType(forest2ID, "new england forest");
        rmSetAreaForestDensity(forest2ID, 1.0);
        rmSetAreaForestClumpiness(forest2ID, 0.0);
        rmSetAreaForestUnderbrush(forest2ID, 0.0);
        rmSetAreaMinBlobs(forest2ID, 1);
        rmSetAreaMaxBlobs(forest2ID, 1);
        rmSetAreaMinBlobDistance(forest2ID, 1.0);
        rmSetAreaMaxBlobDistance(forest2ID, 1.0);
        rmSetAreaCoherence(forest2ID, 1.0);
        rmSetAreaSmoothDistance(forest2ID, 10);
        rmAddAreaToClass(forest2ID, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2ID, forestConstraint);
		//rmAddAreaConstraint(forest2ID, avoidCloseNatives);
		//rmAddAreaConstraint(forest2ID, avoidCloseDeer);
		//rmAddAreaConstraint(forest2ID, avoidCloseMoose);
		rmSetAreaLocation(forest2ID, 0.65, 0.35); 
        rmBuildArea(forest2ID);
		
		int forest3ID = -1;
        forest3ID=rmCreateArea("forest 3");
        rmSetAreaWarnFailure(forest3ID, false);
        rmSetAreaSize(forest3ID, 0.025, 0.025);
        rmSetAreaForestType(forest3ID, "new england forest");
        rmSetAreaForestDensity(forest3ID, 1.0);
        rmSetAreaForestClumpiness(forest3ID, 0.0);
        rmSetAreaForestUnderbrush(forest3ID, 0.0);
        rmSetAreaMinBlobs(forest3ID, 1);
        rmSetAreaMaxBlobs(forest3ID, 1);
        rmSetAreaMinBlobDistance(forest3ID, 1.0);
        rmSetAreaMaxBlobDistance(forest3ID, 1.0);
        rmSetAreaCoherence(forest3ID, 1.0);
        rmSetAreaSmoothDistance(forest3ID, 10);
        rmAddAreaToClass(forest3ID, rmClassID("classForest")); 
        rmAddAreaConstraint(forest3ID, forestConstraint);
		//rmAddAreaConstraint(forest3ID, avoidCloseNatives);
		//rmAddAreaConstraint(forest3ID, avoidCloseDeer);
		//rmAddAreaConstraint(forest3ID, avoidCloseMoose);
		rmSetAreaLocation(forest3ID, 0.20, 0.50); 
        rmBuildArea(forest3ID);
		
		int forest4ID = -1;
        forest4ID=rmCreateArea("forest 4");
        rmSetAreaWarnFailure(forest4ID, false);
        rmSetAreaSize(forest4ID, 0.025, 0.025);
        rmSetAreaForestType(forest4ID, "new england forest");
        rmSetAreaForestDensity(forest4ID, 1.0);
        rmSetAreaForestClumpiness(forest4ID, 0.0);
        rmSetAreaForestUnderbrush(forest4ID, 0.0);
        rmSetAreaMinBlobs(forest4ID, 1);
        rmSetAreaMaxBlobs(forest4ID, 1);
        rmSetAreaMinBlobDistance(forest4ID, 1.0);
        rmSetAreaMaxBlobDistance(forest4ID, 1.0);
        rmSetAreaCoherence(forest4ID, 1.0);
        rmSetAreaSmoothDistance(forest4ID, 10);
        rmAddAreaToClass(forest4ID, rmClassID("classForest")); 
        rmAddAreaConstraint(forest4ID, forestConstraint);
		//rmAddAreaConstraint(forest4ID, avoidCloseNatives);
		//rmAddAreaConstraint(forest4ID, avoidCloseDeer);
		//rmAddAreaConstraint(forest4ID, avoidCloseMoose);
		rmSetAreaLocation(forest4ID, 0.50, 0.20); 
        rmBuildArea(forest4ID);
		
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE SMALL FORESTS: ************************************ //
/*================================================================================================================*/
         
		int forest5ID = -1;
        forest5ID=rmCreateArea("forest 5");
        rmSetAreaWarnFailure(forest5ID, false);
        rmSetAreaSize(forest5ID, 0.0125, 0.0125);
        rmSetAreaForestType(forest5ID, "new england forest");
        rmSetAreaForestDensity(forest5ID, 1.0);
        rmSetAreaForestClumpiness(forest5ID, 0.0);
        rmSetAreaForestUnderbrush(forest5ID, 0.0);
        rmSetAreaMinBlobs(forest5ID, 1);
        rmSetAreaMaxBlobs(forest5ID, 1);
        rmSetAreaMinBlobDistance(forest5ID, 1.0);
        rmSetAreaMaxBlobDistance(forest5ID, 1.0);
        rmSetAreaCoherence(forest5ID, 1.0);
        rmSetAreaSmoothDistance(forest5ID, 10);
        rmAddAreaToClass(forest5ID, rmClassID("classForest")); 
        rmAddAreaConstraint(forest5ID, forestConstraint);
		//rmAddAreaConstraint(forest5ID, avoidCloseNatives);
		//rmAddAreaConstraint(forest5ID, avoidCloseDeer);
		//rmAddAreaConstraint(forest5ID, avoidCloseMoose);
		rmSetAreaLocation(forest5ID, 0.215, 0.215); 
        rmBuildArea(forest5ID);		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE FISHES AND THE WHALES: ********************************* //
/*================================================================================================================*/
        
		// DEFINE THE CONSTRAINTS:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "FishCod", 8.0);
		int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "minkeWhale", 15.0);
		int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 8.0);

        // DEFINE AND PLACE THE FISHES: 
		int fishID=rmCreateObjectDef("fish 1");
        rmAddObjectDefItem(fishID, "FishCod", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 18*cNumberNonGaiaPlayers);
				
	    // DEFINE AND PLACE THE FAST COIN -- WHALES:
	    int whaleID=rmCreateObjectDef("whale");
        rmAddObjectDefItem(whaleID, "minkeWhale", 1, 9.0);
        rmSetObjectDefMinDistance(whaleID, 0.0);
        rmSetObjectDefMaxDistance(whaleID, 0.0);
        rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
        rmAddObjectDefConstraint(whaleID, whaleLand);
        
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.9);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.925, 0.5); 
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.8, 0.8);
        
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** // 
/*================================================================================================================*/





















